#!/usr/bin/env python
#-*- coding: utf-8 -*-
########################################################################
#
# Copyright (c) 2019 Baidu.com, Inc. All Rights Reserved.
#
########################################################################

import sys
from urllib.parse import urlparse
import bcesigner
import datetime
from urllib.parse import parse_qs

host = "yuqing.bce.baidu.com"
access_key = "xxx"  //用户AK
secret_key = "xxx"  //用户SK


def gen_authorization(method, url):
    """
    normal case
    """
    utc_time = datetime.datetime.utcnow()
    utc_time_str = utc_time.strftime("%Y-%m-%dT%H:%M:%SZ")
    url_parse_ret = urlparse(url)
    query = url_parse_ret.query
    request = {
            'method': method,
            'uri': url_parse_ret.path,
            'params': dict([(k,v[0]) for k,v in parse_qs(query).items()]),
            'headers': {
                'Host': url_parse_ret.hostname
                }
            }
    print(request)
    signer = bcesigner.BceSigner(access_key, secret_key)
    print(signer)
    auth = signer.gen_authorization(request, timestamp=utc_time_str)
    print("auth: %s" % auth )
    return auth

if __name__ == "__main__":
    """test"""
    gen_authorization("GET","http://10.35.160.162:8282/v1/tasks/5/yuqing?hitTypes=ALL&limit=10&mediaTypes=ALL&relevantTypes=RELEVANT&repeatTypes=NO_REPEAT&searchTypes=ALL&sentiment=ALL&sort=RELEVANTASC&start=100&timeFrom=1607961600000&timeTo=1608002063022")
